/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.smartitengineering.demo.selectionsuite.myeditor.books;

import com.smartitengineering.demo.selectionsuite.api.book.BookNode;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.logging.Logger;
import javax.swing.table.AbstractTableModel;
import org.openide.util.Lookup;
import org.openide.util.Lookup.Template;
import org.openide.util.LookupEvent;
import org.openide.util.LookupListener;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;
//import org.openide.util.Utilities;
/**
 * Top component which displays something.
 */
final class SellableBooksTopComponent
    extends TopComponent {

    private static SellableBooksTopComponent instance;
    /** path to the icon used by the component and its open action */
    static final String ICON_PATH = "com/smartitengineering/demo/selectionsuite/myeditor/sell.gif";
    private static final String PREFERRED_ID = "SellableBooksTopComponent";
    private final BookTableModel tableModel;
    private List<BookNode> books;
    private Lookup.Result<BookNode> bookResult;
    private LookupListener bookLookupListener;

    private SellableBooksTopComponent() {
        initComponents();
        tableModel = new BookTableModel();
        sellableBookList.setModel(tableModel);
        setName(NbBundle.getMessage(SellableBooksTopComponent.class,
            "CTL_SellableBooksTopComponent"));
        setToolTipText(NbBundle.getMessage(SellableBooksTopComponent.class,
            "HINT_SellableBooksTopComponent"));
        setIcon(Utilities.loadImage(ICON_PATH, true));
    }

    public List<BookNode> getBooks() {
        if (books == null) {
            return Collections.emptyList();
        }
        return books;
    }

    public void setBooks(List<BookNode> currentNodes) {
        if (currentNodes != null) {
            books = currentNodes;
            tableModel.fireTableDataChanged();
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        bookListScroller = new javax.swing.JScrollPane();
        sellableBookList = new javax.swing.JTable();

        sellableBookList.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        bookListScroller.setViewportView(sellableBookList);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(bookListScroller, javax.swing.GroupLayout.DEFAULT_SIZE, 550, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(bookListScroller, javax.swing.GroupLayout.DEFAULT_SIZE, 354, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane bookListScroller;
    private javax.swing.JTable sellableBookList;
    // End of variables declaration//GEN-END:variables
    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link findInstance}.
     */
    public static synchronized SellableBooksTopComponent getDefault() {
        if (instance == null) {
            instance = new SellableBooksTopComponent();
        }
        return instance;
    }

    /**
     * Obtain the SellableBooksTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized SellableBooksTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(
            PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(SellableBooksTopComponent.class.getName()).warning(
                "Cannot find " + PREFERRED_ID +
                " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof SellableBooksTopComponent) {
            return (SellableBooksTopComponent) win;
        }
        Logger.getLogger(SellableBooksTopComponent.class.getName()).warning(
            "There seem to be multiple components with the '" + PREFERRED_ID +
            "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_ALWAYS;
    }

    @Override
    public void componentOpened() {
        final Lookup actionsGlobalContext = Utilities.actionsGlobalContext();
        final Template<BookNode> personNodeTemplate =
            new Lookup.Template<BookNode>(BookNode.class);
        bookResult = actionsGlobalContext.lookup(personNodeTemplate);
        bookLookupListener = new LookupListener() {
            public void resultChanged(LookupEvent nodeEvent) {
                List<BookNode> nodes = new ArrayList<BookNode>(
                    ((Lookup.Result<BookNode>) nodeEvent.getSource()).allInstances());
                if (nodes != null) {
                    setBooks(nodes);
                }
            }
        };
        bookResult.addLookupListener(bookLookupListener);
        bookResult.allInstances();
    }

    @Override
    public void componentClosed() {
        bookResult.removeLookupListener(bookLookupListener);
    }

    /** replaces this in object stream */
    @Override
    public Object writeReplace() {
        return new ResolvableHelper();
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }

    final static class ResolvableHelper
        implements Serializable {

        private static final long serialVersionUID = 1L;

        public Object readResolve() {
            return SellableBooksTopComponent.getDefault();
        }
    }

    private class BookTableModel
        extends AbstractTableModel {

        public int getRowCount() {
            return getBooks().size();
        }

        public int getColumnCount() {
            return 5;
        }

        public Object getValueAt(int rowIndex,
                                 int columnIndex) {
            if (rowIndex >= getRowCount() || columnIndex >= getColumnCount()) {
                return "";
            }
            BookNode node = getBooks().get(rowIndex);
            switch (columnIndex) {
                case 0:
                    return node.getBookName();
                case 1:
                    return node.isPublished();
                case 2:
                    return node.isEbookAvailable();
                case 3:
                    return node.getStockAmount();
                case 4:
                    return node.getPrice();
                default:
                    return "";
            }
        }
    }
}
